#define		MAXYRS		5
#define		MAXREC		512
#define		MAXFLD		64
#define		MAXFILE 	64
#ifndef		SWORK
#undef		SWORK
#define		SWORK		256
#endif		/*SWORK*/
#define		MAXDATA		MAXFLD*MAXYRS
#define		OFFSET		15	/* offset from right margin */
#define		MAXLN		129	/* maximum line */
#define		MAXDY		25	/* maximum divisions of y axis */
#define		MAXDX		25	/* maximum divisions of x axis */
#define		MINLY		10	/* minimum length of y axis */
#define		MINLX		10	/* minimum length of x axis */
#define		MAXLY		50	/* maximum length of y axis */
#define		MAXLX		110	/* maximum length of x axis */
#define		MAXGRPH		6000	/* maximum graph page size */
/*ALLOCATE*/
#ifdef	ALLOCATE
/**/
char *docform = "%15sFile = [%s]: xvar = %d yvar = %d\n";
char *gpx;
FILE *ifp;
char *nochange = "No set since last change. %s! overrides.\n";
char *noread = "No read since last change. %s! overrides.\n";
char *ob;
FILE *ofp;
char *ylp[MAXLY + 1]; /* pointers to lines of graph */
 /* 2 = filled down */
int fill;
char fm[SWORK + 1];
int form; /* 0 = border; 1 = grid */
int formg;
int fwd;
char ghead[SWORK + 1];
char graph[MAXGRPH]; /* page of points to be graphed */
char ifn[FNMSIZ];
int ixr;
int iyr;
KENV kenv;
int lx = 40;
int ly = 20;
int nddx;
int nddy;
int ndread;
int ndx = 8;
int ndy = 4;
int nsfxx;
int nsfyy;
char ofn[FNMSIZ];
char pxline[SWORK+1];
int redraw;
int shrink;
int symdraw = '*';
int symfill = '!';
double xintv;
double xlower;
double xmax = 100.0;
double xmin;
double xno[MAXDX + 1];
int xpand;
double xrange;
double xscale;
char xtitle[SWORK + 1];
double xupper;
int xvar;
double xx;
int xyswap;
double yintv;
double ylower;
double ymax = 100.0;
double ymin;
double yno[MAXDY + 1];
double yrange;
double yrange;
double yscale;
char ytitle[SWORK + 1];
double yupper;
int yvar;
double yy;
double zz;
#else	ALLOCATE
extern char *docform;
extern char *gpx;
extern FILE *ifp;
extern char *nochange;
extern char *noread;
extern char *ob;
extern FILE *ofp;
extern char *ylp[];
extern int fill;
extern char fm[];
extern int form;
extern int formg;
extern int fwd;
extern char ghead[];
extern char graph[];
extern char ifn[];
extern int ixr;
extern int iyr;
extern KENV kenv;
extern int lx;
extern int ly;
extern int nddx;
extern int nddy;
extern int ndread;
extern int ndx;
extern int ndy;
extern int nsfxx;
extern int nsfyy;
extern char ofn[];
extern char pxline[];
extern int redraw;
extern int shrink;
extern int symdraw;
extern int symfill;
extern double xintv;
extern double xlower;
extern double xmax;
extern double xmin;
extern double xno[];
extern int xpand;
extern double xrange;
extern double xscale;
extern char xtitle[];
extern double xupper;
extern int xvar;
extern double xx;
extern int xyswap;
extern double yintv;
extern double ylower;
extern double ymax;
extern double ymin;
extern double yno[];
extern double yrange;
extern double yscale;
extern char ytitle[];
extern double yupper;
extern int yvar;
extern double yy;
extern double zz;
#endif	ALLOCATE
/*EXTERN*/
extern	int		help();
extern	int		doso();
extern	int		doexit();
extern	int		doread();
extern	char	*getenv();
extern	char	*setifn();
extern	int		setform();
extern	int		display();
extern	int		xdoshell();
extern	int		setsym();
extern	int		doshrink();
extern	int		doexpand();
extern	int		doset();
extern	int		doprint();
extern	int		dograph();
extern	double	atof();
extern	double	setdvar();
extern	int		setivar();
extern	int		toggle();
extern	char	*setstr();
