#ifndef		BUFSIZ
#include	<stdio.h>
#endif
#ifndef		isnull
#define     isnull(x)((x==NULL||*x==NULL)?1:0)
#endif
#define     WHO_AM_I    "kroff"
#define     eosp(c)((c=='.'||c=='?'||c=='!'||c==';')?c:0)
#define     prwc(x)((x>=' '||x==XS)?1:((x=='\010')?-1:((x<0)?1:0)))
#define     isvowel(x)((x=='a'||x=='o'||x=='e'||x=='i'||x=='u'||x=='y')?x:0)
#define     isconso(x)((isalpha(x)&&!isvowel(x))?x:0)
#define     hcode(a,b)( (('a'|HMASK) * 255) + 'b')
#define     inset(c,set)((index(set,c))?1:0)
#define		LINE		'\n'
#define		BACK		'\b'
#define		NO_DIF		== 0
#define		SWORK		BUFSIZ
#define		MWORK		BUFSIZ
#define     HYPHEN      '-'
#define     LCMASK      '\040'
#define     HMASK       '\200'
#define     XHMASK      '\177'
#define     XLINE       128
#define     KRLINE      BUFSIZ
#define     FU  '\020'
#define     FD  '\021'
#define     FR  '\022'
#define     FB  '\023'
#define     FI  '\024'
#define     XC  '\026'
#define     XS  '\027'
#define     XK  '\030'
#define     XW  '\031'
#define     XON '\032'
#define     XOFF    '\033'
#define     HBREAK  '\034'
#define     BATCH_MODE  0
#define     TBR     4
#define     TIP     3
#define     TLP     2
#define     TPP     1
#define     TQE     6
#define     TQS     5
#define     TSH     7
#define     DFM     6
#define     DHM     6
#define     DIN     5
#define     DLL     60
#define     DLS     1
#define     DPS     1
#define     DLT     60
#define     DPI     5
#define     DPL     66
#define     DPO     16
#define     DTI     5
#define     ENDS        0
#define     FOOTS       1
#define     HUGE        9999
#define     NENV        2
#define     NTRAPS      128
struct  KRENV   {
    /* buffers */
    char    inline[KRLINE];
    char    *nisx;
    long    iad;
    char    otline[KRLINE];
    char    *nosx;
    char    *otx;
    long    oad;
    int     llx;                /* length of line after indents */
    int     owc;                /* words in output line */
    int     olw;                /* (current) width of output line */
    int     nolw;               /* (usable)  width of output line */
    /* files */
    FILE    *ifp;               /* input file pointer */
    char    *ifn;               /* input file name */
    FILE    *ofp;               /* output file pointer */
    /* header,footer, title settings */
    int     lt, LT;
    int     hm, HM;
    int     hx;                 /* header off */
    char    he[XLINE];  /* header */
    int     fm, FM;
    int     fx;                 /* footer off */
    char    fo[XLINE];          /* footer */
    /* page format settings */
    int     pl;
    int     lno;                /* lines out */
    int     lni;                /* lines in */
    int     lnc;                /* cummulative lines */
    int     lnt;                /* text lines on page */
    int     cp;                 /* current page */
    int     np;                 /* next page */
    char    pg[5];              /* current page as a string */
    int     bo;                 /* last line of text */
    /* paragraph format settings */
    int     PS;
    int     PI;
    /* line format settings */
    int     fi;
    int     ad;
    int     ll, LL;             /* line length */
    int     in, IN;             /* (basic) indent */
    int     ti, TI;             /* (temporary) indent */
    int     po;
    int     llc;                /* width of current line */
    int     sp;
    int     ls, LS;             /* line spacing */
    /* note parameters */
    int     pnl;                /* note lines pending */
    int     fn;                 /* foot or end note switch */
    int     an;                 /* automatic note numbering */
    int     fc;                 /* note character */
    int     su;                 /* superscript note switch */
    char    *rh;                /* citation header */
    char    *rf;                /* citation footer */
    /* auto referencing */
    int     ar;                 /* auto reference switch */
    char    *fr;                /* name of reference file */
    /* switches */
    int     br;                 /* break on command */
    int     tf;                 /* table formatter is on/off */
    int     ns;                 /* space compression */
    int     ec;                 /* escape character */
    int     hy;                 /* hyphenation */
    int     ev;                 /* environment level */
    int     cc;                 /* control character */
    int     c2;                 /* no-break control chracter */
    int     s1;                 /* single sheet stop */
    int     lx;                 /* trap latch */
    int     si;                 /* output is muted */
    int     sl;                 /* slow with window n */
    int     nm;                 /* (output) line numbering */
    int     wh;                 /* in trap if >= 1 */
    /* fonts and conversions */
    int     tr;                 /* character translation */
    int     ull;                /* line font switch */
    int     ult;                /* term font switch */
    int     to;                 /* terminal underlines */
    int     ce;                 /* centering */
    int     db;                 /* debug mode */
} ;
#define     WORD    XW
#define     totext(y,x){for(y=x;*y&&isalnum(*y);y++);while(isspace(*y))y++;}
#define     kcode(x)((255 * *x) + *(x+1))
#define     KCODE(a,b)((255 * 'a' + 'b'))
#define     TITLE       0
#define     SPACE       0
#define     TEXT        1
#define     VARIABLES
struct  KENV kenv;
int 	xfn;
int 	Elite;
int 	s1;
int 	last;
int 	slow;
int 	lvcmenu;
char    icmd[SWORK];
char    efn[SWORK];
char    inbufa[BUFSIZ];
char    otbufa[BUFSIZ];
struct  KRENV   kenvx[NENV];
struct  KRENV   *envc;
FILE    *pifp;
FILE    *sifp;
FILE    *nufp;
FILE    *fnpr;
FILE    *fnpw;
FILE    *olfp;
char    *fnfn;
#include	<signal.h>
#include	<setjmp.h>
jmp_buf jump_env;
#define     OL_SEP  ','
#define     MAX_OL  32
