#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"

#include	"kawkfunc.h"
/*EXTERN*/
/**/
void
kexpand(na,ap)      /* expand shell variables */
int     na;
DATUM   *ap;
{
    rdx.v.ptr = xpandsh(ap[0].v.ptr,ap[0].v.ptr + ap[1].v.ivalu);
    pusher = spush;
}
void
kuserex(na,ap)      /* use a previously compiled pattern */
int     na;
DATUM   *ap;
{
    rdx.v.ptr = re_exec(ap[0].v.ptr);
    pusher = spush;
}
void
kgetrex(na,ap)      /* compile and find a pattern */
int     na;
DATUM   *ap;
{
    auto    int     nr;
    nr = (int) re_comp(ap[1].v.ptr);
	if(nr)	badpat(ap[0].v.ptr,nr);
    rdx.v.ptr = re_exec(ap[0].v.ptr);
    pusher = spush;
}
void
ksetrex(na,ap)      /* compile a regular expression */
int     na;
DATUM   *ap;
{
    auto    int     nr;
    rdx.v.ivalu = nr = (int) re_comp(ap[0].v.ptr);
	if(nr)	badpat(ap[0].v.ptr,nr);
    pusher = ipush;
}
void
badpat(is,nr)
char	*is;
NOSIGN	nr;
{
        errmsg("<%s> %s\n",is,rex_errs(nr));
		terror(FUBAR);
		return;
}
void
kchange(na,ap)  /* substitution */
int     na;
DATUM   *ap;
{
/*
**  change(os,ns,is,ts,rs,[0-9])
*/
    auto    char    *os = ap[0].v.ptr;
    auto    char    *us = ap[0].v.ptr + ap[1].v.ivalu - 1;
    auto    char    *is = ap[2].v.ptr;
    auto    char    *ts = ap[3].v.ptr;
    auto    char    *rs = ap[4].v.ptr;
    auto    int     gl = ap[5].v.ivalu;
    auto    int     bl = 0;
    bl = (int) re_comp(ts);
    if(bl)  {
        errmsg("<bad pattern> %s\n",rex_errs(bl));
        terror(FUBAR);
        }
    if(*ts == '^')  bl = 1;
    else            bl = 0;
    rdx.v.ivalu = dsub(os,us,is,rs,gl,bl);
    pusher = ipush;
}
