#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "ksysprot.h"
#include	"ksyskwik.h"
#define     NO_KEYS
#define     WORD    '\001'
#define     EOW     '\0'
#undef      EOW
#define     EOW     '\002'
/**/
/*EXTERNAL*/
/**/
char    *
kpc(os,us,is)       /* compile pattern */
char    *os;
char    *us;
char    *is;
{
    REG     char    *isx = is;
    REG     char    *osx = os;
    REG     char    *usx = us - 16;
    REG     char    *cnt = os;
#ifdef	DEBUG
	fprintf(stderr,"(0) kpc(%u,%u,%u)\n",osx,usx,isx);
#endif
/*
**  WORD, SIZE, word, EOW
**  multiple blanks and punctuation removed
*/
    *osx = ZERO;
    while(osx < usx && *isx != ZERO)    {
/**/
    if(isalnum(*isx))   {
	*osx++ = WORD;
	cnt = osx++;
	while(*isx != ZERO)
	if(isspace(*isx))   break;
	else
	if(islower(*isx))   *osx++ = *isx++;
	else
	if(isdigit(*isx))   *osx++ = *isx++;
	else
	if(isupper(*isx))   {
	    *osx++ = tolower(*isx);
	    isx += 1;
	    }
	else                isx += 1;
	*osx++ = EOW;
	*cnt = (char) (osx - cnt) - 2;
	}
    else
#ifdef  NO_KEYS
    if(*isx == LF)  {
	isx += 1;
	while(*isx != ZERO && isalnum(*isx))    ++isx;
	}
    else
#endif
/**/
    if(isspace(*isx))   ++isx;
    else                ++isx;
/**/
    }
    *osx++ = ZERO;
/**/
    if(osx >= usx)  {
	errmsg("kpc <overflow> %u %u\n",os,us);
	*os = ZERO;
	}
#ifdef	DEBUG
	fprintf(stderr,"(1) kpc(%u,%u,%u)\n",osx,usx,isx);
#endif
/**/
    return(osx);
}
kpx(cs,ts)		/* find _ts in _cs */
char    *ts;    /* target string(s) */
char    *cs;    /* text (card) */
{
    REG     char    *csx = cs;
    REG     char    *tsx = ts;
    REG     int     ccnt;
    REG     int     tcnt;
#ifdef	DEBUG
	fprintf(stderr,"kpx(%u,%u)\n",cs,ts);
	if(isnull(cs))	fprintf(stderr,"cs is null in kpx\n");
	if(isnull(cs))	fprintf(stderr,"ts is null in kpx\n");
	if(isnull(cs)||isnull(ts))	terror(FUBAR);
	prtpat(cs);
	prtpat(ts);
#endif
    if(*tsx == ZERO)    return(0);
    while(csx && *tsx != ZERO)  {
/**/
    if(*tsx == WORD)    {
	tcnt = (int) *++tsx;
	tsx += 1;
	{
	    csx = cs;
	    while(*csx != ZERO) {
/**/
	    if(*csx == WORD)    {
		ccnt = (int) *++csx;
		csx += 1;
/**/
/**/
		if(ccnt != tcnt)    ;
		else
		if(*csx != *tsx)    ;
		else
		if(strncmp(csx+1,tsx+1,ccnt-1) == 0)    break;
		csx += (ccnt + 1);
		}
	    else    terror(FUBAR);
	    }
	    if(*csx == ZERO)    return(ZERO);
	}
	tsx += (tcnt + 1);
	}
    else    terror(FUBAR);
    csx += 1;
    }
    return(1);
}
#ifdef	DEBUG
prtpat(is)        /* print pattern */
char    *is;        /* pattern */
{
    REG     char    *isx = is;
    REG     int     nsx;
    if(isnull(is))	{
    	errmsg("prtpat <null pattern>\n");
    	terror(FUBAR);
    	}
    while(*isx != ZERO)
    if(*isx == WORD)    {
	isx += 2;
	while(*isx != ZERO && *isx != EOW)  putc(*isx++,stderr);
	if(*isx == EOW) {
	    putc(' ',stderr);
	    isx += 1;
	    }
	}
    else    {
	errmsg("prpat <pattern error>\n");
	terror(FUBAR);
	}
    putc('\n',stderr);
	return;
}
#endif
