#include	<stdio.h>
#include	<ctype.h>
extern long ftell();
struct	CHANGE	{
	int		act;
	int		head;
	int		tail;
	long	addr;
	}	change[BUFSIZ];
FILE	*lp;
char	ls[BUFSIZ];
int		lc;
int		rl;
int		nfixes;
char	cs[BUFSIZ];
char	fn[128];
char	*fx;
char	*csx;
main(argc,argv)
int		argc;
char	*argv[];
{
	auto	int		ix;
	auto	int		jx;
	strcpy(fn,getenv("EHK"));
	strcat(fn,"/KAWK");
	fx = strlen(fn) + fn;
	for(ix = 1; ix < argc; ix++)	{
		freopen(argv[ix],"r",stdin);
		nfixes = 0;
		while(fgets(cs,BUFSIZ-1,stdin))	{
			switch(cs[0])	{
			case	'a':
			case	'c':
			case	'd':
				change[nfixes].act = cs[0];
				change[nfixes].head = atoi(csx = cs+1);
				while(isdigit(*csx))	++csx;
				change[nfixes].tail = atoi(csx);
				change[nfixes].addr = ftell(stdin);
				nfixes += 1;
				break;
			default:
				fprintf(stderr,"<sync error>\n");
				exit(69);
			}
			while(fgets(cs,BUFSIZ-1,stdin) && cs[0] != '.')	;
			}
		for(jx = 0; jx < nfixes; jx++)	{
			fprintf(stderr,"%s ",argv[ix]);
			fprintf(stderr,"%c ",change[jx].act);
			fprintf(stderr,"%d ",change[jx].head);
			fprintf(stderr,"%d ",change[jx].tail);
			fprintf(stderr,"%ld ",change[jx].addr);
			fprintf(stderr,"\n");
			}
		lp = fopen(argv[ix]+1,"r");
		if(lp == NULL)	{
			perror(argv[ix]+1);
			exit(69);
			}
		lc = 0;
		while(fgets(ls,BUFSIZ-1,lp))	{
			lc += 1;
			jx = hasfix(lc);
			if(jx == 0)	{
					fputs(ls,stdout);
					continue;
					}
			jx -= 1;
			switch(change[jx].act)	{
				case	'c':
					fputs("#ifdef\tOLDER\n",stdout);
					fputs(ls,stdout);
					rl = change[jx].tail - change[jx].head;
					while(rl-- >= 1 &&
						fgets(ls,BUFSIZ-1,lp)) {
							lc += 1;
							fputs(ls,stdout);
							}
					fputs("#else\t/*NEWER*/\n",stdout);
					fseek(stdin,change[jx].addr,0);
					while(fgets(cs,BUFSIZ-1,stdin) &&
						cs[0] != '.')	fputs(cs,stdout);
					fputs("#endif\t/*NEWER*/\n",stdout);
					break;
				case	'd':
					fputs("#ifdef\tOLDER\n",stdout);
					fputs(ls,stdout);
					rl = change[jx].tail - change[jx].head;
					while(rl-- >= 1 &&
						fgets(ls,BUFSIZ-1,lp)) {
							lc += 1;
							fputs(ls,stdout);
							}
					fputs("#endif\t/*OLDER*/\n",stdout);
					break;
				case	'a':
					fputs(ls,stdout);
					fputs("#ifdef\tNEWER\n",stdout);
					fseek(stdin,change[jx].addr,0);
					while(fgets(cs,BUFSIZ-1,stdin) &&
						cs[0] != '.')	fputs(cs,stdout);
					fputs("#endif\t/*NEWER*/\n",stdout);
					break;
				}
			}
		fclose(lp);
		}
}
hasfix(lc)
int		lc;
{
	auto	int		jx;
	for(jx = 0; jx < nfixes; jx++)
		if(change[jx].head == lc)	return(jx+1);
	return(0);
}
